// The example shows a websocket client that is
// sending a text message to a connected server
// once in a second. The echoed response is
// printed to the console.

#INCLUDE "dcdialog.CH"

#define SERVERNAME  GetEnv("Computername" )
#define PORT        81

PROCEDURE Main

LOCAL oPictureClient, GetList[0]

oPictureClient := PictureClient():new( SERVERNAME, "WebSocketPictureServer", PORT )

@ 0,0 DCPUSHBUTTON CAPTION 'Connect' SIZE 10,1.2 ;
      ACTION {|o|oPictureClient:connect(), ;
                 oPictureClient:sendText('current'), ;
                 DC_GetWhen(GetList), ;
                 o := Thread():new(), ;
                 o:start({||oPictureClient:eventLoop()})} ;
      WHEN {||!oPictureClient:isConnected()}

@ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'DisConnect' SIZE 10,1.2 ;
      ACTION {||oPictureClient:disconnect(),DC_GetWhen(GetList)} WHEN {||oPictureClient:isConnected()}

@ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'Previous' SIZE 10,1.2 ;
      ACTION {||oPictureClient:sendText('prev')} WHEN {||oPictureClient:isConnected()}

@ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'Next' SIZE 10,1.2 ;
      ACTION {||oPictureClient:sendText('next')} WHEN {||oPictureClient:isConnected()}

@ 2,0 DCSTATIC TYPE XBPSTATIC_TYPE_BITMAP SIZE 40,10 OBJECT oPictureClient:bitmapStatic

DCREAD GUI TITLE 'Picture Client' FIT

RETURN

* -----------

PROC appsys ; RETURN

* ===============

CLASS PictureClient FROM WebSocketClient
  EXPORTED
    VAR bitmapStatic
    METHOD onText
    METHOD onConnect
    METHOD onDisconnect
    METHOD onBinary
    METHOD eventLoop
ENDCLASS

METHOD PictureClient:onText( cText )
RETURN self

METHOD PictureClient:onBinary( cBinary )
LOCAL oBitmap
oBitmap := XbpBitmap():new():create()
oBitmap:setBuffer(cBinary)
::bitmapStatic:setCaption(oBitmap)
RETURN self

METHOD PictureClient:onConnect()
RETURN self

METHOD PictureClient:onDisconnect()
RETURN self

METHOD PictureClient:eventLoop()
LOCAL lHandled
DO WHILE ::isConnected()
  lHandled := ::handleMessage( .F. )
  Sleep(5)
ENDDO
RETURN nil


