
#define DEFAULT_PORT 81

#include "Gra.ch"
#include "Xbp.ch"
#include "Common.ch"
#include "Appevent.ch"
#include "Font.ch"
#include "web.CH"
#include "Directry.ch"
#include "fileio.ch"
#include "assert.ch"
#INCLUDE "dcdialog.CH"

#PRAGMA LIBRARY( "ascom10.lib" )

PROCEDURE Main

LOCAL oPictureServerUI

SET DEFAULT TO ..\..\data\northwind\dbf

oPictureServerUI := PictureServerUI():new()

oPictureServerUI:shutdown()

RETURN

* ---------

PROCEDURE AppSys() ; RETURN

* ---------

PROCEDURE DbeSys()
  IF .NOT. DbeLoad( "FOXDBE", .F. )
    MsgBox( "Can not load FOXDBE" )
    quit
  ENDIF
RETURN


******************************************************************************
* This class is derived from the implementation-level class of the form.
* Instance variables are declared in the _PictureServer class.
******************************************************************************
CLASS PictureServerUI

   VAR _HttpEndpoint

EXPORTED:

   VAR _ConnectedClientsNum
   VAR _getList
   VAR _isRunning
   VAR _picturePath
   VAR _port
   VAR _computerName

   METHOD init
   METHOD shutdown
   METHOD startup
   METHOD go
   METHOD copyUrl

   // methods invoked by the view model
   METHOD processPicture
   METHOD connected
   METHOD disconnected

   ACCESS METHOD getUrl()   VAR URL
   ACCESS METHOD getWSUrl() VAR WSURL

ENDCLASS

******************************************************************************
* Initialize and create form
******************************************************************************
METHOD PictureServerUI:init( oParent, oOwner, aPos, aSize, aPP, lVisible )

LOCAL GetList[0], GetOptions

::_getList := GetList
::_isRunning := .f.
::_picturePath := ''
::_port := DEFAULT_PORT
::_connectedClientsNum := 0
::_computerName := GetEnv('Computername')

@ 284,24  DCSAY 'Computername:' SAYRIGHTCENTER SIZE 96,24 COLOR nil,-255
@ 284,132 DCSAY ::_computerName SAYVCENTER SIZE 228, 24 COLOR nil, -255 FONT '12.Arial'
@ 260,36  DCSAY 'Port:' SAYRIGHTCENTER SIZE 84,24 COLOR nil, -255
@ 260,432 DCPUSHBUTTON CAPTION 'Start' SIZE 96,24 COLOR -58, XBPSYSCLR_BUTTONMIDDLE ACTION {||::startUp()} WHEN {||!::_isRunning}
@ 236,432 DCPUSHBUTTON CAPTION 'Stop' SIZE 96,24 COLOR -58, XBPSYSCLR_BUTTONMIDDLE ACTION {||::shutDown()} WHEN {||::_isRunning}
@ 212,24  DCSAY 'Connected Clients:' SAYRIGHTCENTER SIZE 96,24 COLOR nil, -255
@ 212,132 DCSAY {||::_connectedClientsNum} SAYVCENTER SIZE 84,24 COLOR {||IIF(::_isRunning,{GRA_CLR_RED,-255},{GRA_CLR_BLACK,-255})}
@ 236,36  DCSAY 'Status' SAYRIGHTCENTER SIZE 84,24 COLOR nil, -255
@ 236,132 DCSAY {||IIF(::_isRunning,'Running','Stopped')} SAYVCENTER SIZE 84,24 COLOR {||IIF(::_isRunning,{GRA_CLR_DARKGREEN,-255},{GRA_CLR_RED,-255})}
@ 260,132 DCSPINBUTTON ::_port SIZE 60,24 COLOR nil, XBPSYSCLR_ENTRYFIELD WHEN {||!::_isRunning}
@ 128, 36 DCSAY 'Browse URL:' SAYRIGHTCENTER SIZE 84,24 COLOR nil, -255
@ 128,132 DCSAY {||IIF(::_isRunning,"http://"+::Url ,'')} SAYVCENTER SIZE 246,24 COLOR nil, -255
@ 320,12  DCSAY 'Server control' SAYHVCENTER SIZE 516,24 COLOR GRA_CLR_WHITE, GRA_CLR_BLUE

@ 176,12  DCSAY 'Information' SAYHVCENTER SIZE 516,24 COLOR GRA_CLR_WHITE, GRA_CLR_DARKGRAY
@ 90,432  DCPUSHBUTTON CAPTION 'Start Browser' SIZE 96,24 COLOR -58, XBPSYSCLR_BUTTONMIDDLE ACTION {||::go(1)} WHEN {||::_isRunning}
@ 114,432  DCPUSHBUTTON CAPTION 'Start Client' SIZE 96,24 COLOR -58, XBPSYSCLR_BUTTONMIDDLE ACTION {||::go(2)} WHEN {||::_isRunning}
@ 138,432 DCPUSHBUTTON CAPTION 'URL to Clipboard' SIZE 96,24 COLOR -58, XBPSYSCLR_BUTTONMIDDLE ACTION {||::copyUrl()}

@ 56,12   DCSAY 'Activity' SAYHVCENTER SIZE 516,24 COLOR GRA_CLR_WHITE, GRA_CLR_BROWN
@ 24,36   DCSAY 'Processing:' SAYRIGHTCENTER SIZE 84,24 COLOR nil, -255
@ 24,132  DCSAY {||::_picturePath} SAYVCENTER SIZE 396,24 COLOR nil, -255

DCGETOPTIONS PIXEL NOTRANSLATE

DCREAD GUI FIT TITLE 'Picture Server' MODAL OPTIONS GetOptions ;
   EVAL {|o|PictureServer(self),WebSocketPictureServer(self)}

RETURN self

METHOD PictureServerUI:shutdown()
  ::_isRunning := .f.
  DC_GetRefresh(::_getList)
  IF .NOT. (NIL==::_HttpEndpoint)
    ::_HttpEndpoint:stop()
    ::_HttpEndpoint := NIL
  ENDIF
  WebSocketPictureServer():closeAll()
RETURN self

METHOD PictureServerUI:startup()
  ::_isRunning := .t.
  DC_GetRefresh(::_getList)
  ::_HttpEndpoint := HttpEndpoint():new(::_port)
  ::_HttpEndpoint:start()
RETURN self

METHOD PictureServerUI:go( nWhich )
  LOCAL cUrl
  IF nWhich == 1
    cUrl := "http://"+::Url
    RunShell( "/C explorer.exe "+cUrl,, .T., .T. )
  ELSE
    RunShell( '','dcpictclient.exe',.t.,.t. )
  ENDIF
RETURN self

METHOD PictureServerUI:copyUrl()
  LOCAL cUrl, oClipBoard
  cUrl := "http://"+::Url

  oClipBoard := XbpClipBoard():new():create()
  oClipBoard:open()
  oClipBoard:clear()
  oClipBoard:setBuffer( cUrl )
  oClipBoard:close()
  oClipBoard:destroy()
RETURN self

METHOD PictureServerUI:processPicture( cPicturePath )
::_picturePath := cPicturePath
DC_GetRefresh(::_getList)
RETURN self

METHOD PictureServerUI:connected()
  ::_ConnectedClientsNum++
  DC_GetRefresh(::_getList)
RETURN self

METHOD PictureServerUI:disconnected()
  ::_ConnectedClientsNum--
  DC_GetRefresh(::_getList)
RETURN self

METHOD PictureServerUI:getUrl()
  LOCAL cUrl := ""
  cUrl += ::_computerName + ":"
  cUrl += AllTrim(Str(::_port))
  cUrl += "/pictureserver/start"
RETURN cUrl

METHOD PictureServerUI:getWSUrl()
  LOCAL cUrl := ""
  cUrl += ::_computerName + ":"
  cUrl += AllTrim(Str(::_port))
  cUrl += "/websocketpictureserver"
RETURN cUrl

* ==================

CLASS PictureServer FROM WebHandler
  PROTECTED:
    CLASS VAR _UI
  EXPORTED:
    CLASS METHOD initClass
          METHOD start
ENDCLASS

CLASS METHOD PictureServer:initClass( oUI )
  ::_UI := oUI
RETURN self

//The URL with the RESTful path "http://<servername>:<port>/PictureServer/start"
//returns the start page.
METHOD PictureServer:start()
  LOCAL cHtml, cUrl
  cUrl  := "ws://"+::_UI:WSUrl
  cHtml := MemoRead("websocketpictureserver.htm")
  cHtml := StrTran( cHtml, "<!--[URL]-->", cUrl )
RETURN cHtml

* ==================

CLASS WebSocketPictureServer FROM WebSocketHandler
  PROTECTED:
    CLASS VAR _UI
    CLASS VAR _Instances
          VAR _Pictures
          VAR _PicturePath
          VAR _WA

    SYNC CLASS METHOD _addSelf
    SYNC CLASS METHOD _delSelf

               METHOD _next
               METHOD _prev
               METHOD _sendCurrentPicture
  EXPORTED:
         CLASS METHOD initClass
    SYNC CLASS METHOD closeAll

               METHOD init
               METHOD onConnect
               METHOD onDisconnect
               METHOD onText
               METHOD onBinary
ENDCLASS

CLASS METHOD WebSocketPictureServer:_addSelf( oSelf )
  AAdd( ::_Instances, oSelf )
RETURN self

CLASS METHOD WebSocketPictureServer:_delSelf( oSelf )
  LOCAL nPos
  nPos := AScan( ::_Instances, oSelf )
  ASSERT( nPos != 0 )
  ARemove( ::_Instances, nPos )
RETURN self

CLASS METHOD WebSocketPictureServer:initClass( oUI )
  ::_UI        := oUI
  ::_Instances := {}
RETURN self

CLASS METHOD WebSocketPictureServer:closeAll()
  LOCAL oInstance, nInstance, nInstances
  nInstances := Len( ::_Instances )
  FOR nInstance := 1 to nInstances
    oInstance := ::_Instances[nInstance]
    oInstance:close()
  NEXT
  ::_Instances := {}
RETURN self

METHOD WebSocketPictureServer:init()

  DbUseArea( .T., "FOXDBE", "employees" )
  ::_WA := Select()

  ::_addSelf(self )

RETURN self

METHOD WebSocketPictureServer:_next()
  DbSkip()
  IF Eof()
    DbGoTop()
  ENDIF
RETURN self

METHOD WebSocketPictureServer:_prev()
  DbSkip(-1)
  IF Bof()
    DbGoBottom()
  ENDIF
RETURN self

METHOD WebSocketPictureServer:_sendCurrentPicture()

  ::sendBinary( (::_WA)->photo )

  ::_UI:processPicture( AllTrim((::_WA)->firstname) + " " + ;
                        AllTrim((::_WA)->lastname) )
RETURN self

METHOD WebSocketPictureServer:onConnect()
  ::_UI:connected()
RETURN self

METHOD WebSocketPictureServer:onDisconnect()
  ::_UI:disconnected()
  (::_WA)->( DbCloseArea() )
  ::_WA := NIL
RETURN self

METHOD WebSocketPictureServer:onText( cText )
  cText := Lower( cText )
  DO CASE
    CASE cText == "current"
      // no navigation here
    CASE cText == "next"
      (::_WA)->( ::_next() )
    CASE cText == "prev"
      (::_WA)->( ::_prev() )
    OTHERWISE
      RETURN
  ENDCASE
  ::_sendCurrentPicture()
RETURN self

METHOD WebSocketPictureServer:onBinary( cBinary )
  Unused( cBinary )
RETURN self



